;; $Id: gui.el,v 1.2 1995/08/28 15:32:11 billl Exp $

;; This file is part of GNU Emacs.

;; GNU Emacs is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY.  No author or distributor
;; accepts responsibility to anyone for the consequences of using it
;; or for whether it serves any particular purpose or works at all,
;; unless he says so in writing.  Refer to the GNU Emacs General Public
;; License for full details.

;; Everyone is granted permission to copy, modify and redistribute
;; GNU Emacs, but only under the conditions described in the
;; GNU Emacs General Public License.   A copy of this license is
;; supposed to have been given to you along with GNU Emacs so you
;; can know your rights and responsibilities.  It should be in a
;; file named COPYING.  Among other things, the copyright notice
;; and this notice must be preserved on all copies.
;; 
;; simctrl package by Bill Lytton - 11/1/93
;; gui.el by Steve Fisher - 8/28/95


(defvar nrn-gui-regexp "\\([]\\[A-Za-z0-9_.]+\\)[ \t]*=[ \t]*\\([-+*/0-9e.]+\\)"
  "Matches 'var name' = 'num'")

(defun hoc-buffer-to-panel ()
"Take params out of a hoc buffer and make a NEURON gui panel from them."
  (interactive)
  (hoc-region-to-panel (point-min) (point-max)))

(defun hoc-region-to-panel (beg end)
  "Take params from region of hoc code and make a NEURON gui panel from them."
  (interactive "r")
  (save-excursion
    (comint-send-string 
     (sim-proc) (format "\nxpanel(\"%s\")\n" (buffer-name)))
    (goto-char beg)
    (while (re-search-forward nrn-gui-regexp end t)
      (setq var (buffer-substring (match-beginning 1) (match-end 1)))
      (comint-send-string 
       (sim-proc) (format "xpvalue(\"%s\",&%s,1)\n" var var)))
    (comint-send-string 
     (sim-proc) (format "\nxpanel()\n"))))
